#
# This is the SPEC file for creating binary and source RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

Name:		qubes-gui-daemon
Version:	4.2.2
Release:	1%{dist}
Summary:	The Qubes GUI virtualization

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

Requires:	xorg-x11-server-Xorg
Requires:	service(graphical-login)
Requires:	libconfig
Requires:   python%{python3_pkgversion}-xcffib
Requires:   qubes-utils >= 3.1.0
Requires:   qubes-core-qrexec >= 4.1.5
Requires:   python%{python3_pkgversion}-qubesimgconverter >= 4.1.4
Requires:   socat
Requires:   group(qubes)

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  pulseaudio-libs-devel
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(x11-xcb)
BuildRequires:	pkgconfig(xcb)
BuildRequires:	pkgconfig(xcb-aux)
BuildRequires:	pkgconfig(xcb-shm)
BuildRequires:	libXrandr-devel
BuildRequires:	libconfig-devel
BuildRequires:	libpng-devel
BuildRequires:	libnotify-devel
BuildRequires:	xen-devel
BuildRequires:	qubes-db-devel
BuildRequires:	help2man
BuildRequires:	gcc
BuildRequires:	qubes-core-libs-devel >= 1.6.1
BuildRequires:	qubes-core-libs
BuildRequires:	qubes-gui-common-devel >= 3.2.0
BuildRequires:	qubes-libvchan-xen-devel

Source0: %{name}-%{version}.tar.gz

%description
The Qubes GUI virtualization infrastructure that needs to be installed in GuiVM.

%package -n qubes-gui-dom0
Summary:    Dom0 part of Qubes GUI
# For now require also gui-daemon in dom0, when dropping GUI in dom0, this
# dependency should be dropped
Requires:   qubes-gui-daemon
# Pull also audio packages for easier upgrade
Requires:   qubes-audio-daemon
Requires:   qubes-audio-dom0
Requires:	qubes-core-dom0 >= 4.1.1
# for policy.EvalSimple service
Requires:	qubes-core-qrexec-dom0 >= 4.1.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-gui-dom0
Dom0 files for Qubes GUI virtualization. This include core-admin extension,
policy files etc.

%package -n qubes-audio-daemon
Summary:	The Qubes AUDIO virtualization
Requires:	pulseaudio-libs
%if 0%{?fedora} >= 35
Requires:	pulseaudio-daemon
%else
Requires:	pulseaudio
%endif
Requires:	libconfig
Requires:   qubes-utils >= 3.1.0
Requires:   python%{python3_pkgversion}-pydbus

%description -n qubes-audio-daemon
The Qubes AUDIO virtualization infrastructure that needs to be installed in AudioVM.

%package -n qubes-audio-dom0
Summary:    Dom0 part of Qubes AUDIO
Requires:	qubes-core-dom0 >= 1.3.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-audio-dom0
Dom0 files for Qubes AUDIO virtualization. This include core-admin extension,
policy files etc.

%prep
%setup -q

%build
%{?set_build_flags}
make clean
make all BACKEND_VMM=xen

%py3_build

%pre

%install
rm -rf $RPM_BUILD_ROOT
%make_install
%py3_install

%triggerin -- xorg-x11-server-Xorg
ln -sf /usr/bin/X-wrapper-qubes /usr/bin/X

%postun
if [ "$1" = 0 ] ; then
	# no more packages left
    ln -sf /usr/bin/Xorg /usr/bin/X
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)
%attr(4750,root,qubes) /usr/bin/qubes-guid
%{_mandir}/man1/qubes-guid.1.gz
/usr/bin/X-wrapper-qubes
%{_libdir}/qubes-gui-daemon/shmoverride.so
%config(noreplace) %{_sysconfdir}/qubes/guid.conf
/etc/xdg/autostart/qubes-screen-layout-watches.desktop
/etc/xdg/autostart/qubes-icon-receiver.desktop
/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
/usr/libexec/qubes/watch-screen-layout-changes
/usr/lib/qubes/icon-receiver
%config %{_sysconfdir}/qubes-rpc/qubes.WindowIconUpdater
%config %{_sysconfdir}/qubes/rpc-config/qubes.WindowIconUpdater

%files -n qubes-audio-daemon
/usr/bin/pacat-simple-vchan
/etc/qubes-rpc/qubes.AudioInputEnable
/etc/qubes-rpc/qubes.AudioInputDisable

%files -n qubes-gui-dom0
%config(noreplace) %{_sysconfdir}/qubes/policy.d/90-default-gui-daemon.policy

%files -n qubes-audio-dom0
%{python3_sitelib}/qubesguidaemon-*.egg-info
%{python3_sitelib}/qubesguidaemon

%changelog
* Fri Feb 03 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-gui-daemon

* Fri Feb 03 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d815f91
- version 4.2.2

* Thu Feb 02 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f10c50e
- Use new qrexec policy format

* Thu Feb 02 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e413294
- rpm: fix files ownership on install

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b40c15a
- version 4.2.1

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 35c8b57
- ci: drop R4.1

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f136d83
- rpm: drop explicit libvchan dependency

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 81c0832
- Deal with delayed pulseaudio agent startup

* Wed Jan 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - efa9c89
- pulse: Fix indentation

* Fri Dec 02 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 328b628
- version 4.2.0

* Sun Oct 30 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ca28b9d
- Remove unneeded header includes

* Sun Oct 30 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 6c1763d
- Fix some -Wconversion warnings

* Sun Oct 16 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 9ac7897
- Rip out subwindows support

* Sun Oct 16 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 12f7d0d
- Fix function prototype mismatches and use poll(2)

* Sat Oct 15 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ac63f20
- Clean up some macros

* Fri Oct 14 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 2b58ea2
- Do not check for WM_STATE changes on the root window

* Fri Oct 14 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - eab7a7a
- Add assertions and comments in do_shm_update

* Fri Oct 14 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 32df049
- Make the build system a bit better

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - a051283
- Better logging and command-line parsing

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 2a81ce2
- Remove remaining use of System V shared memory

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 32a591b
- shmoverride: avoid keeping state for munmap

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - a7c1751
- Use FD passing for shared memory

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - e08744c
- Update shmoverride/README for Xlib → xcb change

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - b266385
- Switch from Xlib to XCB for shared memory

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 3fe759a
- Obtain an XCB graphics context

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 49437f4
- Fix unchecked malloc()

* Sun Oct 02 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 7ca6211
- GUI daemon does not take non-option arguments

* Fri Sep 30 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 58a3bc9
- Strict validation of domain IDs

* Thu Sep 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - a91639e
- Actually unset override-redirect when docking

* Wed Sep 28 2022 Marta Marczykowska-Górecka <marta.maria.gorecka@gmail.com> - ac3f029
- Fix notification to comply with summary/body format

* Tue Aug 30 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - be3ea59
- version 4.1.24

* Fri Aug 26 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 543587c
- Send MSG_DESTROY when destroying a window

* Tue Aug 02 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 11ccbe4
- Send MSG_DESTROY when destroying a window

* Thu Jul 28 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - fb36ff8
- Support pipewire-pulseaudio as well as pulseaudio

* Tue Jul 26 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 8d6ec47
- Minor cleanups

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 649865b
- Use original loop for writing data

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - e22a898
- Block during writing for old agents

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - fde7c37
- Do not try to build vchan sink module

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - c6ce403
- Prevent PulseAudio assertion failure

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 59088c9
- Move definition of _GNU_SOURCE to the makefile

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - abc3920
- Log an error for invalid control commands

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ed0de45
- Only check for newlines in newly read data

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 808ba64
- Properly handle control connection errors

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 56718ca
- send_rec_data(): Avoid blocking on vchan writes

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 7626680
- process_playback_data(): avoid blocking on vchan reads

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 5c81844
- Fix command line parsing

* Mon Jul 25 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - b81dee3
- Properly check return value of snprintf()

* Mon Jul 25 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0512543
- version 4.1.23

* Fri Jul 22 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - afd9a7e
- xside: do not release buffer of the "whole screen" window

* Wed Jul 20 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6d3532b
- version 4.1.22

* Wed Jul 20 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ea022e9
- Allow using older qubes-gui-protocol.h

